/////////////////////////////////////////////////////
// .value

// var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
const QuickNote_pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

// On load of window (for new users will load first time )
// Makes sure the needed prefs are set on OK, and loads default values.

function QuickNote_loadQNSettings()
{
  var pref = getQNPrefs();
  var numberOfTabs = pref.get("numtabs");
  
  if ([1,2,3,4].indexOf(numberOfTabs) == -1) {
    numberOfTabs = 2;
    pref.set("numtabs", numberOfTabs);
  }
  
  document.getElementById('numtab-radiogroup').value = numberOfTabs;
  // Set how many TABS (notes) are shown to the user (default are 2)
  if(numberOfTabs == 2)
  {
    document.getElementById('QNTabTwoFileB').collapsed = false;
    document.getElementById('choose-tab2').disabled = false;
    document.getElementById('tabadvanced2').collapsed = false;
  } else if(numberOfTabs == 3)
  {
    document.getElementById('QNTabTwoFileB').collapsed = false;
    document.getElementById('QNTabThreeFileB').collapsed = false;

    document.getElementById('choose-tab2').disabled = false;
    document.getElementById('choose-tab3').disabled = false;

    document.getElementById('tabadvanced2').collapsed = false;
    document.getElementById('tabadvanced3').collapsed = false;
  } else if(numberOfTabs == 4)
  {
    document.getElementById('QNTabTwoFileB').collapsed = false;
    document.getElementById('QNTabThreeFileB').collapsed = false;
    document.getElementById('QNTabFourFileB').collapsed = false;

    document.getElementById('choose-tab2').disabled = false;
    document.getElementById('choose-tab3').disabled = false;
    document.getElementById('choose-tab4').disabled = false;

    document.getElementById('tabadvanced2').collapsed = false;
    document.getElementById('tabadvanced3').collapsed = false;
    document.getElementById('tabadvanced4').collapsed = false;
  } else if(numberOfTabs == 1)
  {
  } else
  {
    alert("Error, unexpected quicknote.numtabs preference value");
  }

  // ## Get Font Size, Colour and Type
  //try{
  var i;
  var numerals = ["", "One", "Two", "Three", "Four"]; // a quick hack. We need to change the |id|s during settings rewrite.
  for(i=1; i<=4; i++) {
    document.getElementById('QNTab'+numerals[i]+'FontColor').color = pref.get("fontcolor",i);
    document.getElementById('QNTab'+numerals[i]+'Fontsizetb').value = pref.get("fontsize",i);
    document.getElementById('QNTab'+numerals[i]+'FontName').value = pref.get("fontname",i);
    document.getElementById('UserStyleDefTab'+i).value = pref.get("userstyle",i);
    document.getElementById('QNTab'+numerals[i]+'BGColor').color = pref.get("bgcolortab",i);

    // ## User Files Paths  ##
    document.getElementById('QNTab'+numerals[i]+'File').value =  nsPreferences.getLocalizedUnicharPref("quicknote.tab"+i+"path");
  }
/*   } catch (e){
     //Foobar!
           alert("Crap! e=" + e );
   }*/



  // ## Sets the "Send To.." options! And language support options. ##
  var sendTo = pref.get("totabint");
  if( (sendTo < 1) || (sendTo>4) ) {
    sendTo = 1;
    pref.set('totabint', 1);
  }
  document.getElementById("totabint-radiogroup").value = sendTo;

  // ## Send to Text URL  ##
  if(pref.get("showUrl") == true)
    document.getElementById('qn-sendtotextUrl').setAttribute('checked', true);

  // ## Show Save and Save All Buttons  ##
  if (pref.get("hidebuttonbox") == false)
    document.getElementById('showButtons').setAttribute('checked', true);

  // ##AutoSave Prefs ##
  var autosave = pref.get("autosave");
  if (autosave == 0)
  {
    document.getElementById('AutoSave-radiogroup').value = 0;
    document.getElementById('xthCharTB').disabled = true;
    document.getElementById('xthCharLabel').disabled = true;
  }else if (autosave == -1)
  {
    document.getElementById('AutoSave-radiogroup').value = -1;
    document.getElementById('xthCharTB').disabled = true;
    document.getElementById('xthCharLabel').disabled = true;
  }else if (autosave > 0){
    document.getElementById('AutoSave-radiogroup').value = 10;
    document.getElementById('xthCharTB').value = autosave;
  }


  // ## File Encoding##
  document.getElementById('EncodingList').value = pref.get("charset");
  menulist = document.getElementById('EncodingList');
  var cachedEncodings = QuickNote_pref.getCharPref("intl.charsetmenu.browser.cache");
  cachedEncodings = cachedEncodings.split(",");
  var len = cachedEncodings.length <= 10 ? cachedEncodings.length : 10;
  for (i=0; i<len; i++) {
    var newEntry = cachedEncodings[i].match(/\s*(\S*)/)[1];
    menulist.appendItem(newEntry, newEntry); // label, value
  }


  // Get FB toolbar button behavior only if in Firebird
  //UserAgent thanks to DeepestSender
  if(navigator.userAgent.search(/Thunderbird/gi) >= 0) {
    document.getElementById("fbtbfunc-s").disabled = true;
    document.getElementById("fbtbfunc-f").disabled = false;
    // document.getElementById("fbtbfunc-t").disabled = true;
    document.getElementById("openqn-radiogroup").value = QN_FLOAT;
  } else {
    if (navigator.userAgent.search(/Firebird/gi) == -1 && navigator.userAgent.search(/Firefox/gi) == -1 )
      document.getElementById("fbtbfunc-s").disabled = true;
    // we don't actually try to support anything other than sidebar, since XPCNW
    // broke the "send to QN" code in the "QN open in tab" case.
    var openMethod = pref.get("openqn");
    if (openMethod != QN_SIDEBAR)
      openMethod = QN_FLOAT;
    document.getElementById("openqn-radiogroup").value = openMethod;
  }
}

//On OK, sets the prefs chosen by the user.
function QuickNote_acceptQNSettings()
{
  var pref = getQNPrefs();
  pref.set("totabint", document.getElementById("totabint-radiogroup").value);

  var userTabOnepath = document.getElementById('QNTabOneFile').value;
  nsPreferences.setUnicharPref('quicknote.tab1path', userTabOnepath);

  var userTabTwopath = document.getElementById('QNTabTwoFile').value;
  nsPreferences.setUnicharPref('quicknote.tab2path', userTabTwopath);

  var userTabThreepath = document.getElementById('QNTabThreeFile').value;
  nsPreferences.setUnicharPref('quicknote.tab3path', userTabThreepath);

  var userTabFourpath = document.getElementById('QNTabFourFile').value;
  nsPreferences.setUnicharPref('quicknote.tab4path', userTabFourpath);

  if(getQNPrefs().get("firststart")){
    QuickNote_pref.setBoolPref('quicknote.firststart', false);
  }

  if (document.getElementById('qn-sendtotextUrl').getAttribute('checked') == 'true')
  {
    QuickNote_pref.setBoolPref('quicknote.showUrl', true);
  }else{
    QuickNote_pref.setBoolPref('quicknote.showUrl', false);
  }

   // ## Show Save and Save All Buttons  ##
  if (document.getElementById('showButtons').getAttribute('checked') == 'true')
  {
    QuickNote_pref.setBoolPref('quicknote.hidebuttonbox', false);
  }else{
    QuickNote_pref.setBoolPref('quicknote.hidebuttonbox', true);
  }

  // ##AutoSave Prefs ##
  if(document.getElementById('onclose').getAttribute('selected', true)){
    QuickNote_pref.setIntPref('quicknote.autosave', '0');
  }else if(document.getElementById('noautosave').getAttribute('selected', true)){
    QuickNote_pref.setIntPref('quicknote.autosave', '-1');
  }else{
    var AutosaveValue = document.getElementById('xthCharTB').value;
    QuickNote_pref.setIntPref('quicknote.autosave', AutosaveValue);
  }

  // ## File Encoding##
  var QnEncodingType;
  if (document.getElementById('EncodingList').value == null || document.getElementById('EncodingList').value == "undefined"){
    QnEncodingType = "UTF-8";
    nsPreferences.setUnicharPref('quicknote.charset', QnEncodingType);
  }else{
    QnEncodingType = document.getElementById('EncodingList').value;
    nsPreferences.setUnicharPref('quicknote.charset', QnEncodingType);
  }

  // ## Sets Number of Tabs ##
  pref.set("numtabs", document.getElementById('numtab-radiogroup').value);

  // Set FB toolbar button behavior
  pref.set("openqn", document.getElementById("openqn-radiogroup").value);

  //## Set Tab Font Colors
  try{
  var TabOneFontColor = document.getElementById('QNTabOneFontColor').color;
  nsPreferences.setUnicharPref('quicknote.fontcolor1', TabOneFontColor);
  var TabOneFontSize = document.getElementById('QNTabOneFontsizetb').value;
  QuickNote_pref.setIntPref('quicknote.fontsize1', TabOneFontSize);
  var TabOneFontName = document.getElementById('QNTabOneFontName').value;
  nsPreferences.setUnicharPref('quicknote.fontname1', TabOneFontName);
  var TabOneUserStyle = document.getElementById('UserStyleDefTab1').value;
  nsPreferences.setUnicharPref('quicknote.userstyle1', TabOneUserStyle);
  var TabOneBGColor = document.getElementById('QNTabOneBGColor').color;
  nsPreferences.setUnicharPref('quicknote.bgcolortab1', TabOneBGColor);

  var TabTwoFontColor = document.getElementById('QNTabTwoFontColor').color;
  nsPreferences.setUnicharPref('quicknote.fontcolor2', TabTwoFontColor);
  var TabTwoFontSize = document.getElementById('QNTabTwoFontsizetb').value;
  QuickNote_pref.setIntPref('quicknote.fontsize2', TabTwoFontSize);
  var TabTwoFontName = document.getElementById('QNTabTwoFontName').value;
  nsPreferences.setUnicharPref('quicknote.fontname2', TabTwoFontName);
  var TabTwoUserStyle = document.getElementById('UserStyleDefTab2').value;
  nsPreferences.setUnicharPref('quicknote.userstyle2', TabTwoUserStyle);
  var TabTwoBGColor = document.getElementById('QNTabTwoBGColor').color;
  nsPreferences.setUnicharPref('quicknote.bgcolortab2', TabTwoBGColor);

  var TabThreeFontColor = document.getElementById('QNTabThreeFontColor').color;
  nsPreferences.setUnicharPref('quicknote.fontcolor3', TabThreeFontColor);
  var TabThreeFontSize = document.getElementById('QNTabThreeFontsizetb').value;
  QuickNote_pref.setIntPref('quicknote.fontsize3', TabThreeFontSize);
  var TabThreeFontName = document.getElementById('QNTabThreeFontName').value;
  nsPreferences.setUnicharPref('quicknote.fontname3', TabThreeFontName);
  var TabThreeUserStyle = document.getElementById('UserStyleDefTab3').value;
  nsPreferences.setUnicharPref('quicknote.userstyle3', TabThreeUserStyle);
  var TabThreeBGColor = document.getElementById('QNTabThreeBGColor').color;
  nsPreferences.setUnicharPref('quicknote.bgcolortab3', TabThreeBGColor);

  var TabFourFontColor = document.getElementById('QNTabFourFontColor').color;
  nsPreferences.setUnicharPref('quicknote.fontcolor4', TabFourFontColor);
  var TabFourFontSize = document.getElementById('QNTabFourFontsizetb').value;
  QuickNote_pref.setIntPref('quicknote.fontsize4', TabFourFontSize);
  var TabFourFontName = document.getElementById('QNTabFourFontName').value;
  nsPreferences.setUnicharPref('quicknote.fontname4', TabFourFontName);
  var TabFourUserStyle = document.getElementById('UserStyleDefTab4').value;
  nsPreferences.setUnicharPref('quicknote.userstyle4', TabFourUserStyle);
  var TabFourBGColor = document.getElementById('QNTabFourBGColor').color;
  nsPreferences.setUnicharPref('quicknote.bgcolortab4', TabFourBGColor);

  }catch(e){
    //Foobar!
  }
  alert("Some Settings may require either restarting QuickNote, or restarting the XUL application.");

  window.close();
  // todo: enumerate browser windows, update keys via QuickNote_updateKeys()
}

//Show Hide tab prefs Dynamically!
function QuickNote_showHideTabPaths()
{
    if( document.getElementById('numtab-1').getAttribute('selected') )
    {
     // ## User File box ##
     document.getElementById('QNTabTwoFileB').collapsed = true;
     document.getElementById('QNTabThreeFileB').collapsed = true;
     document.getElementById('QNTabFourFileB').collapsed = true;
     // ## Selected to. ##
     document.getElementById('choose-tab2').disabled = true;
     document.getElementById('choose-tab3').disabled = true;
     document.getElementById('choose-tab4').disabled = true;
     // ## Advanced Tabs. ##
     document.getElementById('tabadvanced2').collapsed = true;
     document.getElementById('tabadvanced3').collapsed = true;
     document.getElementById('tabadvanced4').collapsed = true;
    }
    if( document.getElementById('numtab-2').getAttribute('selected') )
    {
     document.getElementById('QNTabTwoFileB').collapsed = false;
     document.getElementById('QNTabThreeFileB').collapsed = true;
     document.getElementById('QNTabFourFileB').collapsed = true;

      // ## Selected to. ##
     document.getElementById('choose-tab2').disabled = false;
     document.getElementById('choose-tab3').disabled = true;
     document.getElementById('choose-tab4').disabled = true;

     document.getElementById('tabadvanced2').collapsed = false;
     document.getElementById('tabadvanced3').collapsed = true;
     document.getElementById('tabadvanced4').collapsed = true;
    }
    if( document.getElementById('numtab-3').getAttribute('selected') )
    {
     document.getElementById('QNTabTwoFileB').collapsed = false;
     document.getElementById('QNTabThreeFileB').collapsed = false;
     document.getElementById('QNTabFourFileB').collapsed = true;

      // ## Selected to. ##
     document.getElementById('choose-tab2').disabled = false;
     document.getElementById('choose-tab3').disabled = false;
     document.getElementById('choose-tab4').disabled = true;

     document.getElementById('tabadvanced2').collapsed = false;
     document.getElementById('tabadvanced3').collapsed = false;
     document.getElementById('tabadvanced4').collapsed = true;
    }
    if( document.getElementById('numtab-4').getAttribute('selected') )
    {
     document.getElementById('QNTabTwoFileB').collapsed = false;
     document.getElementById('QNTabThreeFileB').collapsed = false;
     document.getElementById('QNTabFourFileB').collapsed = false;

      // ## Selected to. ##
     document.getElementById('choose-tab2').disabled = false;
     document.getElementById('choose-tab3').disabled = false;
     document.getElementById('choose-tab4').disabled = false;

     document.getElementById('tabadvanced2').collapsed = false;
     document.getElementById('tabadvanced3').collapsed = false;
     document.getElementById('tabadvanced4').collapsed = false;
    }
}

////////////////////////////////////////////////////////////////////////////////
// loaduserFile
//
// Desc: Loads the files by launching the FilePicker
// Parameters: targetNodeID: tab to which the file will be loaded
// Returns: false on error.
////////////////////////////////////////////////////////////////////////////////
function QuickNote_loaduserFile(targetNodeID) {
  var myUserDirPlease = DirIO.get('UChrm').path;
  var fName = QuickNote_txtFilePicker("Open a Text File",0,myUserDirPlease);
  if(fName==null){
      alert("Either you didn't choose a file, or the file you chose was invalid.\n The last used file has been reverted.");
  }else{
    document.getElementById(targetNodeID).value = fName;
  }
  //alert("You must restart your browser or the QuickNote window for the new files to be used.");

}

////////////////////////////////////////////////////////////////////////////////
// txtFilePicker
//
// Parameters:
//  aTitle: title to go on file picker window
//  aSave: 1 if picking file to save/overwrite, 0 if picking file to load
//  aStart: directory to start from
//    This must be an nsILocalFile.  new Dir("foo") in jslib/io/dir.js will
//    do the trick, but you have to do it yourself.
// Returns:
//  Name of file picked, in URL format, or null if cancelled
// Original taken and modified from Tagzilla.mozdev.org!
////////////////////////////////////////////////////////////////////////////////
function QuickNote_txtFilePicker(aTitle, aSave) {
  var retVal = null;
  try {

    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, aTitle, (aSave ? nsIFilePicker.modeSave : nsIFilePicker.modeOpen));
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    /*
    if(aStart) {
      fp.displayDirectory = aStart;
    }
    */
    var result=fp.show();
    if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
      //retVal=fp.fileURL.spec;
      retVal=fp.file.path;
      //alert("Should return retval: "+retVal+" YES!"); // DEBUG
    }
  }
  catch (ex) {
  }
  return retVal;
}
////////////
